'From Squeak3.4 of 1 March 2003 [latest update: #5170] on 27 October 2003 at 10:55:40 pm'!
"Change Set:		MVC-Tutorial
Date:			27 October 2003
Author:			Boris Gaertner

This is the counter example from the MVC tutorial that - many years ago - was written by Krasner and Pope. Look at the comment of class CounterView for further informations."!

Model subclass: #Counter
	instanceVariableNames: 'value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Tutorial'!
MouseMenuController subclass: #CounterController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Tutorial'!
View subclass: #CounterView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MVC-Tutorial'!

!CounterView commentStamp: 'BG 10/27/2003 15:43' prior: 0!
This is the view for the first example from the MVC tutorial from Kranser and Pope. To open the simple counter window, execute this statement:

CounterView open

The menu of the counter is called with the left mouse button.

To open the enhanced couter window, execute this statement:

CounterView openWithGraphicalButtons!


!Counter methodsFor: 'accessing' stamp: 'BG 10/27/2003 12:51'!
value
   " Answer the current value of the receiver"
   ^value! !

!Counter methodsFor: 'accessing' stamp: 'BG 10/27/2003 12:52'!
value: aNumber
   " Initialize the counter to value aNumber"
   value := aNumber.
   self changed.  " to update displayed value "! !

!Counter methodsFor: 'initialize-release' stamp: 'BG 10/27/2003 12:51'!
initialize
   " Set the intitial value to 0."
    self value: 0.! !

!Counter methodsFor: 'operations' stamp: 'BG 10/27/2003 12:52'!
decrement
     " subtract 1 from the value of the counter "
     self value: value - 1.! !

!Counter methodsFor: 'operations' stamp: 'BG 10/27/2003 12:52'!
increment
     " add 1 to the value of the counter "
     self value: value + 1.! !


!Counter class methodsFor: 'instance creation' stamp: 'BG 10/27/2003 12:53'!
new
    " Answer an initialized instance of the receiver"

   ^super new initialize  " return a new instance"! !


!CounterController methodsFor: 'control defaults' stamp: 'BG 10/27/2003 13:01'!
isControlActive

  ^super isControlActive & sensor blueButtonPressed not! !

!CounterController methodsFor: 'initialize-release' stamp: 'BG 10/27/2003 12:59'!
initialize
   "initialize a manue of commands for changing the value of the model"
   super initialize.
   self redButtonMenu:
           (PopUpMenu labels: 'increment\decrement' withCRs)
        redButtonMessages: #(increment decrement)

   " here we use the red button menu "! !

!CounterController methodsFor: 'menu messages' stamp: 'BG 10/27/2003 13:00'!
decrement
   " subtract 1 from the value of the counter "
   self model decrement! !

!CounterController methodsFor: 'menu messages' stamp: 'BG 10/27/2003 13:00'!
increment
   " add 1 to the value of the counter "
   self model increment! !

!CounterController methodsFor: 'pluggable menus' stamp: 'BG 10/27/2003 13:17'!
getPluggableYellowButtonMenu: shiftKeyState
	^ nil! !


!CounterView methodsFor: 'controller access' stamp: 'BG 10/27/2003 13:04'!
defaultControllerClass
   " answer the class of a typically useful controller"
   ^CounterController.
  ! !

!CounterView methodsFor: 'displaying' stamp: 'BG 10/27/2003 14:34'!
displayView
     | box pos displayText |
   box := self insetDisplayBox.
   pos := box origin + (4 @ ((box extent y / 3) rounded)).
   displayText := ('value: ', self model value printString) asDisplayText.
   displayText foregroundColor: Color black
                 backgroundColor: Color white.
   displayText displayAt: pos.! !

!CounterView methodsFor: 'updating' stamp: 'BG 10/27/2003 13:03'!
update: aParameter
   "simply redislplay everything"
   self display.! !


!CounterView class methodsFor: 'instance creation' stamp: 'BG 10/27/2003 13:09'!
open
   " open a view for a new counter"
   " select and execute this comment to test this method:"
   "CounterView open"
   | aCounterView topView |

   aCounterView := CounterView new
             model: Counter new.
   aCounterView borderWidth: 2.
   aCounterView insideColor: Color white.
   topView := StandardSystemView new
                 label: 'Counter'.
   topView minimumSize: 80 @ 40;
             maximumSize: 120 @ 100.
   topView addSubView: aCounterView.
   topView controller open
! !

!CounterView class methodsFor: 'instance creation' stamp: 'BG 10/27/2003 15:41'!
openWithGraphicalButtons
   " open a view for a new counter"
   " select and execute this comment to test this method:"
   "CounterView openWithGraphicalButtons"
   | aCounterView topView incrButton decrButton 
    incrSwitchView decrSwitchView dt textStyle |

   aCounterView := CounterView new
             model: Counter new.
   aCounterView borderWidthLeft: 1 right: 2 top: 2 bottom: 2.
   aCounterView insideColor: Color white.
   topView := ColorSystemView new
                 label: 'Counter'.
   topView minimumSize: 100 @ 40;
             maximumSize: 260 @ 220.
   incrButton := Button newOff.
   incrButton onAction: [aCounterView model increment].
   incrSwitchView := PluggableButtonView on: incrButton
			getState: #isOn
			action: #turnOn.
   textStyle := (TextStyle named: 'NewYork') copy.
   dt := ('+' asText addAttribute: TextFontChange font4) allBold asDisplayText.
   dt foregroundColor: Color black
      backgroundColor: Color lightGreen.
   dt textStyle: textStyle.
   incrSwitchView label: dt.
   incrSwitchView borderWidthLeft: 2 right: 1 top: 2 bottom: 1;
                      insideColor: Color lightGreen.
   incrSwitchView window: (0 @ 0 extent: 40 @ 50).
   topView addSubView: incrSwitchView toLeftOf: aCounterView.
   decrButton := Button newOff.
   decrButton onAction: [aCounterView model decrement].
   decrSwitchView := PluggableButtonView on: decrButton
			getState: #isOn
			action: #turnOn.
   dt := ('-' asText addAttribute: TextFontChange font4) allBold asDisplayText.
   dt foregroundColor: Color black
      backgroundColor: Color lightRed.

   decrSwitchView label: dt.
   decrSwitchView borderWidthLeft: 2 right: 1 top: 1 bottom: 2;
                      insideColor: Color lightRed.
   decrSwitchView window: (0 @ 0 extent: 40 @ 50).
   aCounterView window: (0 @ 0 extent: 60@100).
   topView addSubView: decrSwitchView below: incrSwitchView.
   topView addSubView: aCounterView toRightOf: incrSwitchView.

   topView controller open
! !

